<?php

namespace Modules\Lpj\Services;
use Modules\Lpj\Models\Permohonan;
use Illuminate\Http\Request;

class LaporanUserService
{
    public function getUserPemohon($search = null)
    {
        return Permohonan::join('users', 'users.id', '=', 'permohonan.user_id')
            ->whereNotNull('permohonan.nomor_registrasi')
            ->when($search, function ($query) use ($search) {
                $query->where('users.name', 'like', "%$search%");
            })
            ->select('users.id', 'users.name')
            ->distinct()
            ->orderBy('users.name')
            ->limit(20)
            ->get();
    }


    public function dataForDatatables(Request $request)
    {

        // Retrieve data from the database
        $query = Permohonan::query();
        $query = $query->where('status', 'done');

        // Apply search filter if provided
        if ($request->has('search') && !empty($request->get('search'))) {
            $search = json_decode($request->get('search'));

            if (isset($search->start_date) || isset($search->end_date)) {
                $query->whereBetween('tanggal_permohonan', [
                    $search->start_date ?? '1900-01-01',
                    $search->end_date ?? now()->toDateString()
                ]);
            }

            // Filter by branch if provided
            if (isset($search->user_id) && !empty($search->user_id)) {
                $query->where('user_id', $search->user_id);
            }

            if (isset($search->search)) {

                $query->where(function ($q) use ($search) {
                    $q->where('nomor_registrasi', 'LIKE', '%' . $search->search . '%');
                    $q->orWhere('tanggal_permohonan', 'LIKE', '%' . $search->search . '%');
                    $q->orWhereRelation('user', 'name', 'LIKE', '%' . $search->search . '%');
                    $q->orWhereRelation('tujuanPenilaian', 'name', 'LIKE', '%' . $search->search . '%');
                    $q->orWhereRelation('branch', 'name', 'LIKE', '%' . $search->search . '%');
                    $q->orWhereRelation('jenisFasilitasKredit', 'name', 'LIKE', '%' . $search->search . '%');
                    $q->orWhereRelation('jenisPenilaian', 'name', 'LIKE', '%' . $search->search . '%');
                    $q->orWhere('status', 'LIKE', '%' . $search->search . '%');
                });
            }
        }

        // Apply sorting if provided
        if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
            $order  = $request->get('sortOrder');
            $column = $request->get('sortField');
            $query->orderBy($column, $order);
        }

        // Get the total count of records
        $totalRecords = $query->count();

        // Apply pagination if provided
        if ($request->has('page') && $request->has('size')) {
            $page   = $request->get('page');
            $size   = $request->get('size');
            $offset = ($page - 1) * $size; // Calculate the offset

            $query->skip($offset)->take($size);
        }

        // Get the filtered count of records
        $filteredRecords = $query->count();

        // Get the data for the current page
        $data = $query->with(['debiture.branch'])->get();

        $data = $data->map(function ($permohonan) {

            $npw             = 0;


            if (isset($permohonan->penilai->lpj)) {
                $lpj = json_decode($permohonan->penilai->lpj, true);
                $npw = str_replace('.', '', $lpj['total_nilai_pasar_wajar'] ?? 0);
            }

            return [
                'id'                        => $permohonan->id,
                'nomor_registrasi'          => $permohonan->nomor_registrasi,
                'branch'                    => $permohonan->debiture->branch?->name,
                'name'                      => $permohonan->debiture?->name,
                'pemohon'                   => $permohonan->creator?->name,
                'tanggal_permohonan' => $permohonan->tanggal_permohonan,
                'nama_penilai'              => $permohonan->penilaian?->_user_penilai?->userPenilaiTeam?->name,
                'tanggal_laporan'    => $permohonan->approval_dd_at ?? $permohonan->approval_eo_at ?? '',
                 'nilai_pasar_wajar'         => formatRupiah($npw, 2)
            ];
        });

        // Calculate the page count
        $pageCount = ceil($totalRecords / $request->get('size'));

        // Calculate the current page number
        $currentPage = $request->get('page') ?: 1;

        // Return the response data as a JSON object
        return response()->json([
            'draw'            => $request->get('draw'),
            'recordsTotal'    => $totalRecords,
            'recordsFiltered' => $filteredRecords,
            'pageCount'       => $pageCount,
            'page'            => $currentPage,
            'totalCount'      => $totalRecords,
            'data'            => $data,
        ]);
    }
}
